;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram - konfigurci beolvassa
;
;-----------------------------------------------------------------
;


;
;
;	Konfigurcis fjl megnyitsa s beolvassa
;	in:  -
;	out: -
;
fk_conf:xor	a			; A reg.= 000h
	ld	(plugs),a		; plugin-tblzat trlse
	ld	hl,(0003Eh)		; HL a program betltsi tvonalra mutat
	call	fk_pcp0			; tvonal msolsa a string bufferbe
	ld	hl,cfg_fname		; HL a konfigurcis fjl 8+3-as nevre mutat
	call	fk_frst			; els keresse
	or	a
	ret	nz			; visszatrs, ha nem tallhat a konfig fjl
	ld	de,FCB_0		; FCB_0 a tallt meghatrozott FCB
	ld	hl,FCB_1		; FCB_1 a keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
	call	fk_fish			; FISH funkci hvsa
	or	a
	ret	nz			; visszatrs, ha hiba trtnt
	ld	ix,(L0BF0h)		; IX= cl memriacm (az ltalnos lemezpuffer)
	ld	bc,(L0BF2h)		; BC= maximlisan olvasand bjtok szma (puffer mrete)
	ld	a,00Fh			; funkcikd: olvass fjlbl
	call	fk_fish			; FISH funkci hvsa
	cp	0ECh
	ret	nz			; visszatrs, ha nem .EOF hiba
	ld	a,b			; BC= olvasott bjtok szma
	or	c
	ret	z			; visszatrs, ha nincs feldolgozand karakter

;
;	Fjl feldolgozsa
;
	ld	de,(L0BF0h)		; DE a beolvasott fjl elejre mutat
	ld	(ix),000h		; lezr nulla elhelyezse a fjl vgre
fk_cfg0:ld	a,(de)
	inc	de
	cp	'*'			; kulcssz keresse
	jr	nz,fk_cfg3		; ugrs, ha nem kulcssz kvetkezik
	ld	hl,cfg_keys		; HL a kulcsszavak tblzatra mutat
fk_cfg1:push	de			; els vizsgland karakter cme a verembe
	ld	b,(hl)			; B= kulcssz hossza
	inc	hl
	call	fk_cmp1			; kulcssz sszehasonltsa
	ld	c,b
	ld	b,000h
	add	hl,bc			; HL a kulcs utni rutincmre mutat (ZF vltozatlan)
	jr	z,fk_cfg4		; ugrs, ha egyezik a kulcssz
	pop	de
	or	a
	ret	z			; visszatrs, ha elrte a fjl vgt
	inc	hl
	inc	hl			; HL a kvetkez kulcs hosszra mutat
	ld	a,(hl)
	or	a
	jr	nz,fk_cfg1		; ugrs, ha mg nem rt a kulcs-tblzat vgre
fk_cfg2:ld	a,(de)			; kvetkez karakter vizsglata
	inc	de
	cp	00Ah
	jr	z,fk_cfg0		; ugrs, ha jsor karakter volt
fk_cfg3:or	a
	ret	z			; visszatrs, ha mr nincs feldolgozand karakter
	jr	fk_cfg2			; mutat nvelse a sor vgig
;
fk_cfg4:pop	bc			; verem kitakartsa
	ld	a,(de)			; kvetkez karakter vizsglata
	cp	021h
	jr	nc,fk_cfg0		; ugrs, ha nincs szkz karakter a kulcssz utn
	call	fk_nch			; kvetkez feldolgozhat karakterre ll
	ret	c			; visszatrs, ha vge a fjlnak
	ld	a,(hl)			; rutincm betltse HL-be
	inc	hl
	ld	h,(hl)
	ld	l,a
	jp	(hl)			; ugrs a kulcsszt feldolgoz rutinra


;
;	Konfigurcis kulcsszavak tblzata
;
cfg_keys:
	.db	004h,"MODE"
	.dw	cfg_mode
	.db	004h,"SORT"
	.dw	cfg_sort
	.db	007h,"PLUGINS"
	.dw	cfg_plugins
	.db	006h,"COLORS"
	.dw	cfg_colors
	.db	000h			; tblzatot zr nulla bjt	



cfg_fname
	.db	"SDC     CFG"		; konfigurcis fjl 8+3-as neve


;
;
;	MODE - Grafikus md indulskor
;	in:  DE - aktulis karakter cme
;	out: DE - az utoljra feldolgozott karakterre mutat
;
cfg_mode:
	call	cfg_num			; 8-bites decimlis szm olvassa
	ret	c			; visszatrs, ha vge a fjlnak
	jr	nz,cf_mod0		; ugrs,ha nem volt rvnyes szm
	ld	a,(00080h)
	inc	a
	jr	z,cf_mod0		; ugrs, ha melegindts van
	ld	a,(stmod)		; a parancssorban megadott "-G" kapcsol figyelembe vtele
	or	l
	and	001h			; a md csak 0 vagy 1 lehet
	ld	(stmod),a
cf_mod0:jp	fk_cfg0			; ugrs a fjl tovbbi feldolgozsra


;
;
;	SORT - Rendezsi md indulskor
;	in:  DE - aktulis karakter cme
;	out: DE - az utoljra feldolgozott karakterre mutat
;
cfg_sort:
	call	cfg_num			; 8-bites decimlis szm olvassa
	ret	c			; visszatrs, ha vge a fjlnak
	jr	nz,cf_srt1		; ugrs,ha nem volt rvnyes szm
	ld	a,(00080h)
	inc	a
	jr	z,cf_srt1		; ugrs, ha melegindts van
	ld	a,(de)			; rendezsi irny olvassa
	sub	'+'
	ld	b,a			; B= 000h ha +
	jr	z,cf_srt0		; ugrs, ha +
	dec	a
	dec	a
	jr	nz,cf_srt1		; ugrs, ha nem -
	ld	b,080h
cf_srt0:ld	a,l
	and	007h
	or	b
	ld	(sorttype),a		; rendezsi md trolsa
	inc	de
cf_srt1:jp	fk_cfg0			; ugrs a fjl tovbbi feldolgozsra


;
;
;	PLUGINS - Kiterjesztsekhez rendelt kls programok tblzatnak ellltsa
;	in:  DE - aktulis karakter cme
;	out: DE - az utoljra feldolgozott karakterre mutat
;
cfg_plugins:
	ld	hl,plugs		; HL a plugin-tblzat elejre mutat
cf_plg0:ld	(hl),000h		; tblzatot zr nulla elhelyezse
	ld	a,(de)
	cp	'*'			; '*' karakter vizsglata a konfig fjlban
	jp	z,fk_cfg0		; ha vge a plugin definciknak, akkor ugrs a fjl tovbbi feldolgozsra
	or	a
	ret	z			; visszatrs, ha vge a fjlnak
	push	hl			; bejegyzs kezdcme a verembe
	pop	ix			; kezdcm IX-be
	inc	hl
	ld	b,003h			; kiterjeszts 3 karakternek tmsolsa lesz
cf_plg1:ld	a,(de)
	or	a
	ret	z			; visszatrs, ha vge a fjlnak
	inc	de
	call	fk_nagy			; karakter konvertlsa nagy betv, ha szksges
	ld	(hl),a			; trols a tblzatban
	inc	hl
	djnz	cf_plg1
	call	fk_nch			; SPACE vagy TAB tlpse
	ret	c			; visszatrs, ha vge a fjlnak
	ex	de,hl
cf_plg2:ld	a,(hl)			; msoland karakter A reg.-be is
	cp	021h			; vezrl-karakterek ellenrzse
	jr	c,cf_plg3		; ugrs, ha SPACE vagy annl kisebb sorszm karakter
	ldi				; karakter tmsolsa, DE s HL nvelse
	jr	cf_plg2
;
cf_plg3:or	a
	ret	z			; visszatrs, ha vge a fjlnak
	xor	a
	ld	(de),a			; lezr nulla elhelyezse az tvonalnv vgre
	inc	de
	ex	de,hl			; HL= ltrehozott bejegyzs utni cm  DE= konfig fjl cm
	call	fk_nch			; kvetkez feldolgozhat karakterre ll
	ret	c			; visszatrs, ha vge a fjlnak
	push	ix
	pop	bc			; BC a bejegyzs kezdcmre mutat
	sbc	hl,bc			; L= a bejegyzs hossza (max. 255)
	ld	a,l
	ld	(bc),a			; hosszbjt elhelyezse
	add	hl,bc			; HL ismt a bejegyzs utni cmre mutat
	jr	cf_plg0			; ugrs a kvetkez kiterjeszts-definci feldolgozsra


;
;
;	COLORS - Sznek belltsa
;	in:  DE - aktulis karakter cme
;	out: DE - az utoljra feldolgozott karakterre mutat
;
cfg_colors:
	ld	l,002h			; a kulcssz utn elszr 2 szmot olvas
	ld	ix,fv_vmod0		; IX a 0. tblzatra mutat
	call	cf_scol			; palettartkek beolvassa s trolsa
	ret	c			; visszatrs, ha vge a fjlnak
	ld	l,004h			; tovbbi 4 szmot olvas
	ld	ix,fv_vmod1		; IX az 1. tblzatra mutat
	call	cf_scol			; palettartkek beolvassa s trolsa
	ret	c			; visszatrs, ha vge a fjlnak
	jp	fk_cfg0			; ugrs a fjl tovbbi feldolgozsra


;
;
;	Szmok beolvassa s trolsa a paletta tblzatban
;	in:  DE - aktulis karakter cme
;	      L - beolvasand palettartkek szma
;	     IX - a grafikustblzat elejre mutat
;	out: DE - az utoljra feldolgozott karakterre mutat
;	     CY - CY=1 -> nincs tbb karakter
;
cf_scol:push	hl
	call	cfg_num			; 8-bites decimlis szm olvassa
	ld	a,l			; szm A reg.-be
	pop	hl
	ret	c			; visszatrs, ha vge a fjlnak
	ret	nz			; visszatrs, ha nem rvnyes a szm
	ld	(ix+1),a		; rtk trolsa
	inc	ix			; IX a kvetkez cmre mutat
	dec	l
	jr	nz,cf_scol		; ismtls a megadott szm palettartkig
	ret


;
;
;	8 bites szm beolvassa DE mutatta stringbl
;	in:  DE - karakterlncra mutat
;	out:  A - hibakd
;	     DE - az utoljra feldolgozott karakterre mutat
;	      L - binrisra konvertlt 8 bites szm
;	     ZF - ZF=1 -> rvnyes szm
;	     CY - CY=1 -> nincs tbb karakter
;
cfg_num:call	fk_nch			; az els feldolgozhat karakterre ll
	ret	c			; visszatrs, ha vge a fjlnak
	call	get_num			; DE mutatta karakter decimlis szmjeggy konvertlsa
	jr	c,cfg_nm1		; ugrs, ha nem szmjegy volt
	xor	a			; A reg.= 0
cfg_nm0:ld	l,a			; eddigi konverzik eredmnye L-be
	call	get_num			; DE mutatta karakter decimlis szmjeggy konvertlsa
	ld	h,a			; konvertlt szmjegy H-ba
	ccf
	sbc	a,a
	ret	z			; visszatrs, ha a legutols konvertls sikertelen volt (A reg.= 0)
	inc	de			; DE a kvetkez karakterre mutat
	ld	a,l
	call	cfg_mul			; A reg.= L * 4
	call	nc,cfg_mul		; A reg.= L * 10
	jr	c,cfg_nm1		; ugrs, ha tlcsorduls volt
	add	a,h			; egyesek hozzadsa A reg.-hez
	jr	nc,cfg_nm0		; ugrs, ha a szm mg brzolhat egy bjton
cfg_nm1:ld	a,08Fh			; hibakd: .BADNO - rvnytelen szm
	or	a
	ret


;
;
;	Segdrutin a 10-zel val szorzshoz
;	in:   A - paramter
;	      L - paramter
;	out:  A - A reg.= (A reg. + L) * 2
;	      L - vltozatlan
;	     CY - tlcsorduls jelzse
;
cfg_mul:add	a,l
	ret	c			; visszatrs, ha tlcsorduls volt
	add	a,a
	ret


;
;
;	HL mutatta karakter decimlis szmjeggy konvertlsa
;	in:  DE - konvertland karakterre mutat
;	out:  A - szmrtk 0..9 (ha CY=0)
;	     DE - megrzdik
;	     CY - CY=1 -> sikertelen konvertls
;
get_num:ld	a,(de)			; DE mutatta karakter A reg.-be
	sub	030h
	ret	c			; visszatrs, ha A reg. < '0'
	cp	00Ah
	ccf				; CY=1 ha A reg. > 9
	ret


;
;
;	Karaktermutat nvelse az els feldolgozhat karakterig
;	in:  DE - aktulis karakter cme
;	out: DE - els feldolgozhat karakterre mutat
;	     CY - CY=1 -> nincs tbb karakter
;
fk_nch:	ld	a,(de)			; kvetkez karakter vizsglata
	cp	021h
	ret	nc			; visszatrs, ha feldolgozhat karakter
	or	a
	scf
	ret	z			; visszatrs, ha mr nincs tbb karakter
	inc	de
	jr	fk_nch			; ugrs a folytatsra


.end
